module alt_mem_block


	#(
		parameter DATA_WIDTH = 8,
		parameter ADDR_W = 3,
		parameter MEM_DEPTH = 8
	)
	(
		input clock,
		input [ADDR_W-1:0] r_address,
		input [ADDR_W-1:0] w_address,
		input [DATA_WIDTH-1:0] data_in,
		output reg [DATA_WIDTH-1:0] data_out,
		input write_en,
		input read_en
	);

	(* ramstyle = "no_rw_check" *) reg [DATA_WIDTH-1:0] mem [MEM_DEPTH-1:0]; 

	always @ (posedge clock) begin
		if (write_en) begin
			mem[w_address] <= data_in;
		end
		if (read_en) begin
			data_out <= mem[r_address]; 
		end
	end

endmodule 