module alt_pass_through_ram #
	(
		parameter SIZE = 3,
		parameter WIDTH = 8,
		parameter ADDR_WIDTH = 2
	)(
		output reg [WIDTH-1:0] q,
		input [WIDTH-1:0] d,
		input [ADDR_WIDTH-1:0] write_address, read_address,
		input we, clk
	);
	reg [WIDTH-1:0] mem [SIZE-1:0];
	always @ (posedge clk) begin
		if (we)
			mem[write_address] = d;
		q = mem[read_address]; // q does get d in this clock cycle if we is high
	end
endmodule