// Macnica_i2c.v

// This file was auto-generated as a prototype implementation of a module
// created in component editor.  It ties off all outputs to ground and
// ignores all inputs.  It needs to be edited to make it do something
// useful.
// 
// This file will not be automatically regenerated.  You should check it in
// to your version control system if you want to keep it.

module macnica_i2c
	 (
	input        clk,          // master clock input
	input        reset,        // synchronous active high reset
	input  [2:0] address,      // lower address bits
	input  [31:0]writedata,   // databus input
	output [31:0]readdata,
	input        write,        // write enable input
	input        cs,           // stobe/core select signal
	output wire  waitrequest,  // bus cycle acknowledge output
	output       intr,         // interrupt request signal output
   
   inout  wire       scl_pad_io,
   inout  wire       sda_pad_io
)		;



reg [2:0] reg_address;
wire [7:0] int_readdata;
wire scl_padoen_o;
wire sda_pad_i;
wire sda_pad_o;
wire sda_padoen_o;
wire waitrequest_n;
wire scl_pad_i;
wire scl_pad_o;

i2c_master_top #(1'b1) my_i2c
(
	.wb_clk_i(clk ),
	.wb_rst_i(reset ),
	.arst_i(1'b0 ), 
	.wb_adr_i(address ),
	.wb_dat_i(writedata[7:0] ),
	.wb_dat_o(int_readdata ),
	.wb_we_i(write ),
	.wb_stb_i(cs ),
	.wb_cyc_i(cs ),
	.wb_ack_o(waitrequest_n ),
	.wb_inta_o(intr ),
	.scl_pad_i(scl_pad_i ),
	.scl_pad_o(scl_pad_o ),
	.scl_padoen_o(scl_padoen_o ),
	.sda_pad_i(sda_pad_i ),
	.sda_pad_o(sda_pad_o ),
	.sda_padoen_o(sda_padoen_o )
);


  assign scl_pad_io =(scl_padoen_o) ? 1'bz : scl_pad_o;
  assign sda_pad_io =(sda_padoen_o) ? 1'bz : sda_pad_o;
  assign scl_pad_i = scl_pad_io;
  assign sda_pad_i = sda_pad_io;
   assign waitrequest = ~waitrequest_n;

always@ (posedge clk)

        if (cs) 
            reg_address <= address;
        

assign readdata = int_readdata;

endmodule
