#**************************************************************
# Time Information
#**************************************************************
set_time_format -unit ns -decimal_places 3
#**************************************************************
# Create Clocks
#**************************************************************
create_clock -name clk_100m_fpga -period 100MHz [get_ports {clk_100m_fpga}]
create_clock -name clk_50m_fpga  -period  50MHz [get_ports {clk_50m_fpga }]
create_clock -name i2c_scl_hps -period 400KHz [get_ports {i2c_scl_hps}]
create_clock -name usb_clk -period 480MHz [get_ports {usb_clk}]
create_clock -name vclk_hdmi_rx -period 13.468								
create_clock -name clk_hdmi_rx -period 13.468 -waveform {0.000 6.734} [get_ports {hdmi_rx_pclk}]								

#**************************************************************
# Create Generated Clock
#**************************************************************
derive_pll_clocks -create_base_clocks
#**************************************************************
# Set Clock Latency
#**************************************************************
#**************************************************************
# Set Clock Uncertainty
#**************************************************************
#**************************************************************
# Set Input Delay
#**************************************************************
set_input_delay -clock { u_disp_pll|disp_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk } 5 [get_ports {SCL SDA}]
set_input_delay -clock { clk_100m_fpga } 5 [get_ports {lcd_intr_in}]

#**************************************************************
# Set Output Delay
#**************************************************************
set_output_delay -clock { u_video_pll|video_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk } 5 [get_ports {vid_data[*]}]
set_output_delay -clock { u_video_pll|video_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk } 5 [get_ports {vid_datavalid}]
set_output_delay -clock { u_video_pll|video_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk } 5 [get_ports {vid_h_sync}]
set_output_delay -clock { u_video_pll|video_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk } 5 [get_ports {vid_v_sync}]
set_output_delay -clock { u_video_pll|video_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk } 5 [get_ports {clk_33MHz}]
set_output_delay -clock { u_disp_pll|disp_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk } 5 [get_ports {SCL SDA}]


#**************************************************************
# HDMI Port
#**************************************************************
#max delay constraint								
#**************************************************************
set_input_delay -add_delay -clock [get_clocks {vclk_hdmi_rx}] -max 5.803 [get_ports {hdmi_rx_y[*]}]								
set_input_delay -add_delay -clock [get_clocks {vclk_hdmi_rx}] -max 5.803 [get_ports {hdmi_rx_cbcr[*]}]								
set_input_delay -add_delay -clock [get_clocks {vclk_hdmi_rx}] -max 5.803 [get_ports {hdmi_rx_hs}]								
set_input_delay -add_delay -clock [get_clocks {vclk_hdmi_rx}] -max 5.803 [get_ports {hdmi_rx_vs}]								
set_input_delay -add_delay -clock [get_clocks {vclk_hdmi_rx}] -max 5.803 [get_ports {hdmi_rx_de}]								
#**************************************************************
#min delay constraint								
#**************************************************************
set_input_delay -add_delay -clock [get_clocks {vclk_hdmi_rx}] -min 0.097 [get_ports {hdmi_rx_y[*]}]								
set_input_delay -add_delay -clock [get_clocks {vclk_hdmi_rx}] -min 0.097 [get_ports {hdmi_rx_cbcr[*]}]								
set_input_delay -add_delay -clock [get_clocks {vclk_hdmi_rx}] -min 0.097 [get_ports {hdmi_rx_hs}]								
set_input_delay -add_delay -clock [get_clocks {vclk_hdmi_rx}] -min 0.097 [get_ports {hdmi_rx_vs}]								
set_input_delay -add_delay -clock [get_clocks {vclk_hdmi_rx}] -min 0.097 [get_ports {hdmi_rx_de}]								

#**************************************************************
# LCD Port Disp PLL
#**************************************************************
#max delay constraint								
#**************************************************************
set_output_delay -add_delay -clock [get_clocks {u_disp_pll|disp_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -max 8.01 [get_ports {vid_data[*]}]								
set_output_delay -add_delay -clock [get_clocks {u_disp_pll|disp_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -max 8.01 [get_ports {vid_hs}]								
set_output_delay -add_delay -clock [get_clocks {u_disp_pll|disp_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -max 8.01 [get_ports {vid_vs}]								
set_output_delay -add_delay -clock [get_clocks {u_disp_pll|disp_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -max 8.01 [get_ports {vid_de}]								
#**************************************************************
#min delay constraint								
#**************************************************************
set_output_delay -add_delay -clock [get_clocks {u_disp_pll|disp_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -min -8.01 [get_ports {vid_data[*]}]								
set_output_delay -add_delay -clock [get_clocks {u_disp_pll|disp_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -min -8.01 [get_ports {vid_hs}]								
set_output_delay -add_delay -clock [get_clocks {u_disp_pll|disp_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -min -8.01 [get_ports {vid_vs}]								
set_output_delay -add_delay -clock [get_clocks {u_disp_pll|disp_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -min -8.01 [get_ports {vid_de}]								

#**************************************************************
# LCD Port HDMI TX PLL
#**************************************************************
#max delay constraint								
#**************************************************************
set_output_delay -add_delay -clock [get_clocks {u_hdmi_tx_pll|hdmi_tx_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -max 1.51 [get_ports {vid_data[*]}]								
set_output_delay -add_delay -clock [get_clocks {u_hdmi_tx_pll|hdmi_tx_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -max 1.51 [get_ports {vid_hs}]								
set_output_delay -add_delay -clock [get_clocks {u_hdmi_tx_pll|hdmi_tx_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -max 1.51 [get_ports {vid_vs}]								
set_output_delay -add_delay -clock [get_clocks {u_hdmi_tx_pll|hdmi_tx_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -max 1.51 [get_ports {vid_de}]								
								
#**************************************************************
#min delay constraint								
#**************************************************************
set_output_delay -add_delay -clock [get_clocks {u_hdmi_tx_pll|hdmi_tx_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -min -0.71 [get_ports {vid_data[*]}]								
set_output_delay -add_delay -clock [get_clocks {u_hdmi_tx_pll|hdmi_tx_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -min -0.71 [get_ports {vid_hs}]								
set_output_delay -add_delay -clock [get_clocks {u_hdmi_tx_pll|hdmi_tx_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -min -0.71 [get_ports {vid_vs}]								
set_output_delay -add_delay -clock [get_clocks {u_hdmi_tx_pll|hdmi_tx_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -min -0.71 [get_ports {vid_de}]								
								
#**************************************************************
#setup clock groups for design
#**************************************************************
set_clock_groups -exclusive \
  -group { vclk_hdmi_rx \
           clk_hdmi_rx \
           u_hdmi_rx_pll|hdmi_rx_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk } \
  -group { u_system_pll|system_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk } \
  -group { u_system_pll|system_pll_inst|altera_pll_i|general[1].gpll~PLL_OUTPUT_COUNTER|divclk } \
  -group { u_disp_pll|disp_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk } \
  -group { u_hdmi_tx_pll|hdmi_tx_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk }

#**************************************************************
#asynchronous inputs
#**************************************************************
set_false_path -from [get_ports {int_rx}]
set_false_path -from [get_ports {int_tx}]
set_false_path -from [get_ports {int_tp}]
set_false_path -from [get_keepers {debounce:u_debounce|clean}] 

#**************************************************************
# Set False Path
#**************************************************************
set_false_path -from {u_video_pll|video_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk} -to {clk_100m_fpga}
set_false_path -from {u_video_pll|video_pll_inst|altera_pll_i|general[1].gpll~PLL_OUTPUT_COUNTER|divclk} -to {clk_100m_fpga}
set_false_path -from {u_video_pll|video_pll_inst|altera_pll_i|general[2].gpll~PLL_OUTPUT_COUNTER|divclk} -to {clk_100m_fpga}
set_false_path -from {clk_100m_fpga} -to {u_video_pll|video_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}
set_false_path -from {u_disp_pll|disp_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk} -to [get_ports {vid_pclk}]
set_false_path -from {u_hdmi_tx_pll|hdmi_tx_pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk} -to [get_ports {vid_pclk}]
set_false_path -from {clk_100m_fpga} -to [get_ports {SCL}]
set_false_path -from {clk_100m_fpga} -to [get_ports {SDA}]

# FPGA IO port constraints
set_false_path -from [get_ports {user_pb_fpga[0]}] -to *
set_false_path -from [get_ports {user_pb_fpga[1]}] -to *
set_false_path -from [get_ports {user_pb_fpga[2]}] -to *
set_false_path -from [get_ports {user_dipsw_fpga[0]}] -to *
set_false_path -from [get_ports {user_dipsw_fpga[1]}] -to *
set_false_path -from [get_ports {user_dipsw_fpga[2]}] -to *
set_false_path -from [get_ports {user_dipsw_fpga[3]}] -to *
set_false_path -from * -to [get_ports {user_led_fpga[0]}]
set_false_path -from * -to [get_ports {user_led_fpga[1]}]
set_false_path -from * -to [get_ports {user_led_fpga[2]}]
set_false_path -from * -to [get_ports {user_led_fpga[3]}]
set_false_path -from * -to [get_ports {lcd_intr_led}]
# HPS peripherals port false path setting to workaround the unconstraint path (setting false_path for hps_0 ports will not affect the routing as it is hard silicon)
set_false_path -from * -to [get_ports {enet_hps_gtx_clk}] 
set_false_path -from * -to [get_ports {enet_hps_txd[0]}] 
set_false_path -from * -to [get_ports {enet_hps_txd[1]}] 
set_false_path -from * -to [get_ports {enet_hps_txd[2]}] 
set_false_path -from * -to [get_ports {enet_hps_txd[3]}] 
set_false_path -from * -to [get_ports {enet_hps_mdc}] 
set_false_path -from * -to [get_ports {enet_hps_tx_en}] 
set_false_path -from * -to [get_ports {qspi_ss0}] 
set_false_path -from * -to [get_ports {qspi_clk}] 
set_false_path -from * -to [get_ports {sd_clk}] 
set_false_path -from * -to [get_ports {usb_stp}] 
set_false_path -from * -to [get_ports {spi_sck}] 
set_false_path -from * -to [get_ports {spi_mosi}] 
set_false_path -from * -to [get_ports {spi_csn}] 
set_false_path -from * -to [get_ports {uart_tx}] 
set_false_path -from * -to [get_ports {trace_clk_mic}] 
set_false_path -from * -to [get_ports {trace_data[0]}] 
set_false_path -from * -to [get_ports {trace_data[1]}] 
set_false_path -from * -to [get_ports {trace_data[2]}] 
set_false_path -from * -to [get_ports {trace_data[3]}] 
set_false_path -from * -to [get_ports {trace_data[4]}] 
set_false_path -from * -to [get_ports {trace_data[5]}] 
set_false_path -from * -to [get_ports {trace_data[6]}] 
set_false_path -from * -to [get_ports {trace_data[7]}] 

set_false_path -from * -to [get_ports {enet_hps_mdio}] 
set_false_path -from * -to [get_ports {qspi_io[0]}] 
set_false_path -from * -to [get_ports {qspi_io[1]}] 
set_false_path -from * -to [get_ports {qspi_io[2]}] 
set_false_path -from * -to [get_ports {qspi_io[3]}] 
set_false_path -from * -to [get_ports {sd_cmd}] 
set_false_path -from * -to [get_ports {sd_dat[0]}] 
set_false_path -from * -to [get_ports {sd_dat[1]}] 
set_false_path -from * -to [get_ports {sd_dat[2]}] 
set_false_path -from * -to [get_ports {sd_dat[3]}] 
set_false_path -from * -to [get_ports {usb_data[0]}] 
set_false_path -from * -to [get_ports {usb_data[1]}] 
set_false_path -from * -to [get_ports {usb_data[2]}] 
set_false_path -from * -to [get_ports {usb_data[3]}] 
set_false_path -from * -to [get_ports {usb_data[4]}] 
set_false_path -from * -to [get_ports {usb_data[5]}] 
set_false_path -from * -to [get_ports {usb_data[6]}] 
set_false_path -from * -to [get_ports {usb_data[7]}] 
set_false_path -from * -to [get_ports {i2c_sda_hps}] 
set_false_path -from * -to [get_ports {i2c_scl_hps}] 
set_false_path -from * -to [get_ports {conv_hps_usb_n}] 
set_false_path -from * -to [get_ports {usb_reset}] 
set_false_path -from * -to [get_ports {enet_hps_intn}] 

set_false_path -from [get_ports {enet_hps_mdio}] -to *
set_false_path -from [get_ports {qspi_io[0]}] -to *
set_false_path -from [get_ports {qspi_io[1]}] -to *
set_false_path -from [get_ports {qspi_io[2]}] -to *
set_false_path -from [get_ports {qspi_io[3]}] -to *
set_false_path -from [get_ports {sd_cmd}] -to *
set_false_path -from [get_ports {sd_dat[0]}] -to *
set_false_path -from [get_ports {sd_dat[1]}] -to *
set_false_path -from [get_ports {sd_dat[2]}] -to *
set_false_path -from [get_ports {sd_dat[3]}] -to *
set_false_path -from [get_ports {usb_data[0]}] -to *
set_false_path -from [get_ports {usb_data[1]}] -to *
set_false_path -from [get_ports {usb_data[2]}] -to *
set_false_path -from [get_ports {usb_data[3]}] -to *
set_false_path -from [get_ports {usb_data[4]}] -to *
set_false_path -from [get_ports {usb_data[5]}] -to *
set_false_path -from [get_ports {usb_data[6]}] -to *
set_false_path -from [get_ports {usb_data[7]}] -to *
set_false_path -from [get_ports {i2c_sda_hps}] -to *
set_false_path -from [get_ports {i2c_scl_hps}] -to *
set_false_path -from [get_ports {conv_hps_usb_n}] -to *
set_false_path -from [get_ports {usb_reset}] -to *
set_false_path -from [get_ports {enet_hps_intn}] -to *

set_false_path -from [get_ports {enet_hps_rx_dv}] -to *
set_false_path -from [get_ports {enet_hps_rx_clk}] -to *
set_false_path -from [get_ports {enet_hps_rxd[0]}] -to *
set_false_path -from [get_ports {enet_hps_rxd[1]}] -to *
set_false_path -from [get_ports {enet_hps_rxd[2]}] -to *
set_false_path -from [get_ports {enet_hps_rxd[3]}] -to *
set_false_path -from [get_ports {usb_clk}] -to *
set_false_path -from [get_ports {usb_dir}] -to *
set_false_path -from [get_ports {usb_nxt}] -to *
set_false_path -from [get_ports {spi_miso}] -to *
set_false_path -from [get_ports {uart_rx}] -to *

# for enhancing USB BlasterII to be reliable, 25MHz
create_clock -name {altera_reserved_tck} -period 40 {altera_reserved_tck}
set_input_delay -clock altera_reserved_tck -clock_fall 3 [get_ports altera_reserved_tdi]
set_input_delay -clock altera_reserved_tck -clock_fall 3 [get_ports altera_reserved_tms]
set_output_delay -clock altera_reserved_tck -clock_fall 3 [get_ports altera_reserved_tdo]