set input_switch 0x00010600
set input_switch_dout0_ctl 0x0001060C
set frame_reader 0x00010500
set frame_reader_switch 0x00010580
set frame_reader_switch_dout0_ctl 0x0001058C
set alpha_blender_control 0x00010400
set alpha_blender_status 0x00010404
set alpha_blender_layer1_x 0x00010408
set alpha_blender_layer1_y 0x0001040C
set alpha_blender_layer1_active 0x00010410
set chroma_key 0x00010100
set led_pio 0x00020800
set cvi 0x00010000
set vfb 0x00010080
set vfb_reg4 0x00010090
set scaler_control 0x00010800
set scaler_width   0x0001080C
set scaler_height  0x00010810
#layer definitions for alpha layer control
set layer_off 0
set layer_on  1
set layer_consumed 2

proc blink_leds {} {
puts "Blinking the LEDS"
global led_pio
global master_service_path0 
master_write_8 $master_service_path0 $led_pio 0x0
after 250
master_write_8 $master_service_path0 $led_pio 0xF
after 250
master_write_8 $master_service_path0 $led_pio 0x0
after 250
master_write_8 $master_service_path0 $led_pio 0xF
after 250
master_write_8 $master_service_path0 $led_pio 0x0
after 250
master_write_8 $master_service_path0 $led_pio 0xF
after 250
master_write_8 $master_service_path0 $led_pio 0x0

}

proc show_vfb_status {} {
global vfb
global master_service_path0 
master_read_32 $master_service_path0 $vfb 16
}

proc hdmi_on {} {
global master_service_path0 
global input_switch
global input_switch_dout0_ctl
send_message info "Set Video input path Switch to HDMI (din0)"
#turn off first?
master_write_32 $master_service_path0 $input_switch 0
master_write_32 $master_service_path0 $input_switch_dout0_ctl 1
after 16
master_write_32 $master_service_path0 $input_switch 1
}

proc hdmi_off {} {
global master_service_path0 
global input_switch
global input_switch_dout0_ctl
send_message info "Set Video input path Switch to TPG (din1)"
#turn off first?
master_write_32 $master_service_path0 $input_switch 0
master_write_32 $master_service_path0 $input_switch_dout0_ctl 2
after 16
master_write_32 $master_service_path0 $input_switch 1
}

proc pip_on {} {
global master_service_path0 
global alpha_blender_control     
global alpha_blender_layer1_active
global alpha_blender_layer1_x
global alpha_blender_layer1_y
global alpha_blender_control     
global layer_off
global layer_on
global layer_consumed
send_message info "Set Alpha Blender, PIP=on, Origin=(0,0)"
master_write_32 $master_service_path0 $alpha_blender_control 0
master_write_32 $master_service_path0 $alpha_blender_layer1_x 0
master_write_32 $master_service_path0 $alpha_blender_layer1_y 0
master_write_32 $master_service_path0 $alpha_blender_layer1_active $layer_on
master_write_32 $master_service_path0 $alpha_blender_control 1
master_read_32  $master_service_path0 $alpha_blender_control 5

}

proc pip_xy {x y} {
global master_service_path0 
global alpha_blender_control     
global alpha_blender_layer1_active
global alpha_blender_control     
global alpha_blender_layer1_x
global alpha_blender_layer1_y
master_write_32 $master_service_path0 $alpha_blender_layer1_x $x
master_write_32 $master_service_path0 $alpha_blender_layer1_y $y
puts "Setting PIP origin to $x,$y"
}

proc pip_off {} {
global master_service_path0 
send_message info "Turning off PIP"
global alpha_blender_control     
global alpha_blender_layer1_active
global alpha_blender_control     
global alpha_blender_control     
master_write_32 $master_service_path0 $alpha_blender_control 0
master_write_32 $master_service_path0 $alpha_blender_layer1_active 0
master_write_32 $master_service_path0 $alpha_blender_control 1
master_read_32  $master_service_path0 $alpha_blender_control 5
}

proc set_scaler {width height} {
global master_service_path0 
global scaler_control 
global scaler_width   
global scaler_height  
send_message info "Setting Scaler size to $width X $height"
#turn it off
master_write_32 $master_service_path0  $scaler_control 0
master_write_32 $master_service_path0  $scaler_width $width
master_write_32 $master_service_path0  $scaler_height $height
after 16
master_write_32  $master_service_path0  $scaler_control 1
}

proc set_alpha {value} {
global master_service_path0 
global chroma_key
send_message info "Setting chroma key value to 50% transparency"
#turn it off
master_write_32 $master_service_path0  $chroma_key 0
master_write_32 $master_service_path0  [expr $chroma_key + 0x08] $value
after 16
master_write_32  $master_service_path0  $chroma_key 1
}

proc animate {} {
pip_xy 0 0
#hdmi_off
#hdmi_on
set_scaler 400 240
after 32
set_scaler 420 250
after 32
set_scaler 440 260
after 32
set_scaler 460 270
after 32
set_scaler 480 280
after 32
set_scaler 500 290
after 32
set_scaler 520 300
after 32
set_scaler 540 310
after 32
set_scaler 560 320
after 32
set_scaler 580 330
after 32
set_scaler 600 340
after 32
set_scaler 620 350
after 32
set_scaler 640 360
after 32
set_scaler 660 370
after 32
set_scaler 680 380
after 32
set_scaler 700 390
after 32
set_scaler 720 400
after 32
set_scaler 740 410
after 32
set_scaler 760 420
after 32
set_scaler 780 430
after 32
set_scaler 800 440
after 32
set_scaler 400 240

}
proc background_tpg {} {
global master_service_path0
global frame_reader_switch_dout0_ctl
global frame_reader_switch

    master_write_32 $master_service_path0  $frame_reader_switch_dout0_ctl 2
    master_write_32 $master_service_path0  $frame_reader_switch 1
}

proc background_linux {} {
global master_service_path0
global frame_reader_switch_dout0_ctl
global frame_reader_switch

    master_write_32 $master_service_path0  $frame_reader_switch_dout0_ctl 1
    master_write_32 $master_service_path0  $frame_reader_switch 1
}

proc help {} {
puts "Commands"
puts "============================================="
puts "animate           demo of different scale settings"
puts "background_tpg    Sets the background to TPG output"
puts "blink_leds        Blinks the LEDS three times"
puts "hdmi_off          Sets input to TPG"
puts "hdmi_on           Sets input to HDMI"
puts "help              Displays this help menu"
puts "pip_off           Disables Picture-in_Picture"
puts "pip_on            Enables Picture-in-Picture"
puts "pip_xy            Sets origin for PIP window"
puts "set_alpha value   Sets the alpha blend value for PIP"
puts "set_scaler x y    Sets scaler output size"
puts "show_alpha        alpha demo"
puts "show_vfb_status   Dumps Video Frame Buffer Registers"
puts "status            Shows status of CVI and VFB"

}
proc show_alpha {} {
global chroma_key
global master_service_path0
master_write_32 $master_service_path0  [expr $chroma_key + 0x08] 0
for {set i 0} {$i <256} {incr i} {
    master_write_32 $master_service_path0  [expr $chroma_key + 0x08] [expr $i] 
    after 16
} 

for {set i 0} {$i <256} {incr i} {
    master_write_32 $master_service_path0  [expr $chroma_key + 0x08] [expr 255 - $i] 
    after 16
} 
master_write_32 $master_service_path0  [expr $chroma_key + 0x08] 0x0

}

proc set_alpha {value} {
global chroma_key
global master_service_path0
master_write_32 $master_service_path0  [expr $chroma_key + 0x08] $value

}





proc status {} {
global master_service_path0
global cvi
global vfb
set width [master_read_32 $master_service_path0 [expr $cvi + 0x10] 1]
set lines [master_read_32 $master_service_path0 [expr $cvi + 0x14] 1]
set status_word [master_read_32 $master_service_path0 [expr $cvi + 0x4] 1]
scan $width %x dec_width
scan $lines %x dec_lines
set stable [expr $status_word & 0x00000100]
puts "HDMI: Input Stable = [expr $stable >> 8]"
puts "HDMI: Input: $dec_width x $dec_lines"

set frame_counter  [master_read_32 $master_service_path0 [expr $vfb + 8] 1]
set drop_counter   [master_read_32 $master_service_path0 [expr $vfb + 0x0c] 1]
scan $frame_counter %x dec_frames
scan $drop_counter %x dec_drop
puts "VFB: Frames Received = $dec_frames"
puts "VFB:  Frames Dropped = $dec_drop"
}
send_message info ""
send_message info ""
send_message info ""
send_message info ""
send_message info "======================="
send_message info "Initializing Helio View"
send_message info "======================="
send_message info ""
send_message info "Opening services to Master0"
#send_message info "Master0 --> direct connection to Avalon peripherals (LEDs, buttons, etc)"
#send_message info "Master1 --> HPS AXI slave port to f2h_sdram1_data"
#send_message info "Master2 --> HPS AXI slave port to f2h_axi_slave"


get_service_paths master
set master_service_path0  [lindex [get_service_paths master] 0 ]
#set master_service_path0 1 [lindex [get_service_path0 s master] 1 ]
#set master_service_path0 2 [lindex [get_service_path0 s master] 2 ]
open_service master $master_service_path0 

set_scaler 400 240
set_alpha 0x80
background_tpg
hdmi_on

send_message info "Enable Clocked video input module"
master_write_32 $master_service_path0  $cvi 1
send_message info "Set Video Frame Buffer mode - no fixed rate conversion"
master_write_32 $master_service_path0  $vfb_reg4 0
send_message info "Enable Video Frame Buffer"
master_write_32 $master_service_path0  $vfb 1

 
puts ""
after 100
pip_on
pip_xy 50 50


puts " *****************   MACNICA mPRESSION  ******************** "
puts "                                                              "
puts "     #    #        #               #     #                    "
puts "     #    #        #               #     #                    "
puts "     #    #   ##   #  #   ###       #   #  #     #   #     #  "
puts "     ######  #  #  #     #   #      #   #      #  #  #     #  "
puts "     #    #  ####  #  #  #   #       # #   #   ####  #  #  #  "
puts "     #    #  #     #  #  #   #        #    #   #     # # # #  "
puts "     #    #   ##   #  #   ###         #    #    ##    #   #   "
puts ""                                
puts "type help for commands"
send_message info "==================================="
send_message info "Helio View Initialization Complete."
help
#send_message info "Type help for commands."

